<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "user_functions.php" );

$isadmin = CheckUserAdmin();

function GenerateHeader( $pagetitle = "EverList", $nomargin = FALSE, $tinymce = FALSE )
{
	require( "config.php" );
	
	?><html>
	
	<head>
	<title><?php print $pagetitle; ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<meta name="Author" content="Kris Craig">
	<meta name="Description" content="EverList - A free email listserv written in PHP">
	<meta name="Keywords" content="everlist listserv email mail mailing list users web interface kris craig evergreen tesc">
	<link rel="stylesheet" type="text/css" href="main.css" />
	<link rel="stylesheet" type="text/css" href="other.css" />
	<script language="JavaScript">
	<!--
	function confirmDelete( forumname )
	{
		var agree = confirm( "Are you sure you want to PERMANENTLY delete the forum " + forumname + " ??" );
		if ( agree )
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	// -->
	</script>
	<script language="JavaScript">
	function HelpWindow( url )
	{
		window.open( url, "helpwindow", "width=500, height=400, resizable=no, scrollbars=yes, toolbar=no, location=no, directories=no, status=yes, menubar=no, copyhistory=no, left=100, top=100, screenX=100, screenY=100" );
	}
	</script>
	
	<?php
	if ( $nomargin == TRUE )
	{
		?>
		<style type="text/css">
		
		<!--
		body { 
		  margin-top: 0px;
		  margin-right: 0px;
		  margin-bottom: 0px;
		  margin-left: 0px
		}
		
		
		-->
		
		</style>
		<?php
	}
	
	$thispage = NULL;
	for ( $parseloop = strlen( $_SERVER["PHP_SELF"] ) - 1; $parseloop >= 0; $parseloop-- )
	{
		if ( strcmp( $_SERVER["PHP_SELF"]{$parseloop}, "/" ) == 0 )
		{
			break;
		}
		
		$thispage .= $_SERVER["PHP_SELF"]{$parseloop};
	}
	$thispage = strrev( $thispage );
	
	if ( $tinymce == TRUE )
	{
		$tinymcedir = "tiny_mce/tinymce/";
		
		$isadmin = CheckUserAdmin();
		
		if ( $isadmin == TRUE )
		{
			$codetxt = "code,";
		}
		else
		{
			$codetxt = NULL;
		}
		
		/* Simple textarea.  --Kris */
		/*
		?>
		<script language="javascript" type="text/javascript" src="<?php print $tinymcedir; ?>jscripts/tiny_mce/tiny_mce.js"></script>
		<script language="javascript" type="text/javascript">
		tinyMCE.init({
			mode : "textareas"
		});
		</script>
		
		<?php
		*/
		
		/* Advanced textarea (default).  --Kris */
		
		if ( strcasecmp( $thispage, "register.php" ) == 0 
			|| strcasecmp( $thispage, "control_panel.php" ) == 0 
			|| strcasecmp( $thispage, "manageusers.php" ) == 0 )
		{
		/* Buttons arranged for less width.  --Kris */
		?>
		<script language="javascript" type="text/javascript" src="<?php print $tinymcedir; ?>jscripts/tiny_mce/tiny_mce_src.js"></script>
		<script type="text/javascript">
			tinyMCE.init({
				// General options
				mode : "textareas",
				height : 300,
				theme : "advanced",
				forced_root_block : false,
				force_br_newlines : true,
				force_p_newlines : false,
				document_base_url : "<?php print $siteurl . "/"; ?>",
				plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
		
				// Theme options
				theme_advanced_buttons1 : "<?php print $codetxt; ?>save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,fontselect,fontsizeselect",
				theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,image",
				theme_advanced_buttons3 : "cleanup,help,|,insertdate,inserttime,preview,|,forecolor,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,",
				theme_advanced_buttons4 : "tablecontrols,|,iespell,media,advhr,|,print,|,fullscreen",
				theme_advanced_toolbar_location : "top",
				theme_advanced_toolbar_align : "left",
				theme_advanced_statusbar_location : "bottom",
				theme_advanced_resizing : true,
		
				// Example content CSS (should be your site CSS)
				content_css : "mainr.css",
		
				// Drop lists for link/image/media/template dialogs
				template_external_list_url : "lists/template_list.js",
				external_link_list_url : "lists/link_list.js",
				external_image_list_url : "lists/image_list.js",
				media_external_list_url : "lists/media_list.js"
			});
		</script>
		<?php
		}
		else
		{
		?>
		<script language="javascript" type="text/javascript" src="<?php print $tinymcedir; ?>jscripts/tiny_mce/tiny_mce_src.js"></script>
		<script type="text/javascript">
			tinyMCE.init({
				// General options
				mode : "textareas",
				height : 300,
				theme : "advanced",
				forced_root_block : false,
				force_br_newlines : true,
				force_p_newlines : false,
				document_base_url : "<?php print $siteurl . "/"; ?>",
				plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
		
				// Theme options
				theme_advanced_buttons1 : "<?php print $codetxt; ?>save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,fontselect,fontsizeselect",
				theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,image,cleanup,help,|,insertdate,inserttime,preview,|,forecolor",
				theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,fullscreen",
				theme_advanced_toolbar_location : "top",
				theme_advanced_toolbar_align : "left",
				theme_advanced_statusbar_location : "bottom",
				theme_advanced_resizing : true,
		
				// Example content CSS (should be your site CSS)
				content_css : "main.css",
		
				// Drop lists for link/image/media/template dialogs
				template_external_list_url : "lists/template_list.js",
				external_link_list_url : "lists/link_list.js",
				external_image_list_url : "lists/image_list.js",
				media_external_list_url : "lists/media_list.js"
			});
		</script>
		<?php
		}
		
	}
	
	?>
	</head>
	
	<body bgcolor="white" text="black" link="green" vlink="darkgreen" alink="blue">
	
	<?php
}

function GenerateFooter( $footerwidth = "764" )
{
	?>
	<table border="0" cellspacing="0" cellpadding="0" width="<?php print $footerwidth; ?>">
	<tr>
	<td align="center">
	<br />
	<br />
	<br />
	<br />
	
	<hr width="100%" style="color: #BBBBBB" />
	
	<p align="center" class="footertext">
	EverList - A free email listserv written in PHP.
	<br />
	This software is open-source, licensed under the <a href="http://www.opensource.org/licenses/gpl-3.0.html" target="_blank">GNU General Public License</a>.
	<br />
	Created by <a href="http://www.kriscraig.com" name="Kris Craig" id="Kris Craig" title="Kris Craig" target="_blank">Kris Craig</a>.
	</td>
	</tr>
	</table>
	
	<br />
	
	</body>
	
	</html>
	<?php
}

function GenerateTop( $userdata = array() )
{
	require( "config.php" );
	
	$profiledata = array();
	$profiledata = LoadProfile( $userdata["userid"] );
	
	if ( trim( $profiledata["currentforumid"] ) != NULL )
	{
		$forumdata = array();
		$forumdata = LoadForum( $profiledata["currentforumid"] );
	}
	else
	{
		$forumdata = array();
		$forumdata["fname"] = "<b style=\"color: #FF5555\">None</b>";
	}
	
	?>
	<table border="0" bgcolor="#006331" cellpadding="0" cellspacing="0" width="764">
	<tr>
	<td align="left" width="245">
	<a href="http://www.sourceforge.net/projects/everlist" target="_blank" title="EverList">
	<img src="images/everlist_logo.gif" alt="EverList" align="left" width="177" height="35" border="0" />
	</a>
	</td>
	<td align="right" valign="middle" width="543">
	<table border="0" cellspacing="0">
	<tr>
	<td align="right">
	<?php
	if ( $userdata["authstatus"] == 1 )
	{
		?><font face="Verdana, Arial, Helvetica, sans-serif" color="#66FF99" size="1">Current forum: <?php print $forumdata["fname"]; ?></font></td> <?php
	}
	else
	{
		?><font face="Verdana, Arial, Helvetica, sans-serif" color="#66FF99" size="2"><a href="login.php" class="toptext"><b>Login</b></a></font></td> <?php
	}
	
	?>
	<td>
	<img src="images/space1px.gif" width="5" height="8" alt="|" />
	</td>
	<td valign="bottom">
	</td>
	</tr>
	<tr>
	<td colspan="1" align="right">
	<?php
	if ( $userdata["authstatus"] == 1 )
	{
		?><a href="logout.php"><font face="Verdana, Arial, Helvetica, sans-serif" color="#66FF99" size="1">Logout: </font></a>
		<font face="Verdana, Arial, Helvetica, sans-serif" color="#66FF99" size="1"><?php print $userdata["email"]; ?></font><?php
	}
	
	?>
	</td>
	<td>
	</td>
	<td valign="top" align="right">
	</td>
	</tr>
	</table>
	</td>
	<td valign="top" align="right" width="10">
	<img src="images/space1px.gif" height="2" width="10" alt="" />
	</td>
	</tr>
	<tr>
	<td colspan="3">
	<img src="images/space1px.gif" height="9" width="1" alt="" />
	</td>
	</tr>
	</table>
	<table border="0" cellpadding="0" cellspacing="0" width="734" bgcolor="#006331">
	<tr>
	<td valign="baseline" align="left"><img src="images/dot.gif" height="4" width="115" border="0" alt="" /></td>
	
	<?php
	if ( strcasecmp( $thispage, "all_forums.php" ) == 0 )
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td></td><td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/unsel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/sel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else if ( strcasecmp( $thispage, "messages.php" ) == 0 
		|| strcasecmp( $thispage, "viewtopic.php" ) == 0 
		|| strcasecmp( $thispage, "viewforum.php" ) == 0 )
	{
		?>
		<td valign="baseline" align="left"><img src="images/sel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/sel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/unsel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/unsel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else if ( strcasecmp( $thispage, "search.php" ) == 0 )
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/sel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/unsel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/unsel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else if ( strcasecmp( $thispage, "my_forums.php" ) == 0 )
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/unsel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/sel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/unsel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else if ( strcasecmp( $thispage, "all_forums.php" ) == 0 
		|| strcasecmp( $thispage, "index.php" ) == 0 
		|| $thispage == NULL )
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/unsel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/sel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else if ( strcasecmp( $thispage, "about.php" ) == 0 )
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/unsel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/unsel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/sel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else if ( strcasecmp( $thispage, "control_panel.php" ) == 0 )
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/sel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/unsel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	else
	{
		?>
		<td valign="baseline" align="left"><img src="images/unsel_borderleft.gif" border="0" width="12" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="messages.php"><img border="0" alt="messages" height="22" width="63" src="images/unsel_messages.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="search.php"><img border="0" alt="search" height="22" width="47" src="images/unsel_search.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_left.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="control_panel.php"><img border="0" alt="my_account" height="22" width="74" src="images/sel_my-account.gif" /></a></td><td valign="baseline" align="left"><img src="images/sel_right.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="my_forums.php"><img border="0" alt="my_forums" height="22" width="69" src="images/unsel_my-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="all_forums.php"><img border="0" alt="all_forums" height="22" width="67" src="images/unsel_all-forums.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_middle.gif" border="0" width="14" height="22" alt="" /></td>
		<td valign="baseline" align="left"><a href="about.php"><img border="0" alt="about" height="22" width="44" src="images/unsel_about.gif" /></a></td><td valign="baseline" align="left"><img src="images/unsel_borderright.gif" border="0" width="14" height="22" alt="" /></td>
		<?php
	}
	
	?>
	<td valign="baseline" align="left"><img src="images/dot.gif" height="4" width="156" border="0" alt="" /></td>
	<td valign="baseline" align="left"><a href="about.php"><img src="images/question_shaded.gif" height="17" width="15" border="0" alt="help" /></a></td>
	<td valign="baseline" align="left"><img src="images/dot.gif" height="4" width="18" border="0" alt="" /></td>
	</tr>
	</table>
	
	<table border="0" cellpadding="0" cellspacing="0" width="764">
	<tr>
	<td align="center" width="100%">
	
	<br />
	<br />

	<?php
	
	$topdata = array();
	$topdata["userdata"] = array();
	$topdata["userdata"] = $userdata;
	$topdata["profiledata"] = array();
	$topdata["profiledata"] = $profiledata;
	$topdata["forumdata"] = array();
	$topdata["forumdata"] = $forumdata;
	
	return $topdata;
}

function GenerateBottom()
{
	?>
	</td>
	</tr>
	</table>
	
	<?php
}

function LoadProfile( $userid )
{
	require( "config.php" );
	
	if ( !is_numeric( $userid ) || trim( $userid ) == NULL || $userid <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid userid - '$userid'!" );
	}
	
	$query = "select * from profiles where userid='$userid'";
	$resultLP1 = mysql_query( $query ) or die( "Query '$query' failed for resultLP1 in common.php : " . mysql_error() );
	
	$profiledata = array();
	while ( $line = mysql_fetch_array( $resultLP1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLP1, $sqloop );
			$profiledata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $userid != $profiledata["userid"] )
	{
		return array( "success" => FALSE, "errmsg" => "No matching profile for userid '$userid'!" );
	}
	
	$profiledata["success"] = TRUE;
	
	return $profiledata;
}

function LoadProfiles()
{
	require( "config.php" );
	
	$query = "select * from profiles order by fullname ASC";
	$resultLPs1 = mysql_query( $query ) or die( "Query '$query' failed for resultLPs1 in common.php : " . mysql_error() );
	
	$profilesdata = array();
	$profilesdata[0] = 0;
	while ( $line = mysql_fetch_array( $resultLPs1, MYSQL_ASSOC ) )
	{
		$profilesdata[0]++;
		$profilesdata[$profilesdata[0]] = array();
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLPs1, $sqloop );
			$profilesdata[$profilesdata[0]][$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	$profilesdata["success"] = TRUE;
	
	return $profilesdata;
}

function LoadForum( $forumid )
{
	require( "config.php" );
	
	if ( !is_numeric( $forumid ) || trim( $forumid ) == NULL || $forumid <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid forumid - '$forumid'!" );
	}
	
	$query = "select * from forums where fid='$forumid'";
	$resultLF1 = mysql_query( $query ) or die( "Query '$query' failed for resultLF1 in common.php : " . mysql_error() );
	
	$forumdata = array();
	while ( $line = mysql_fetch_array( $resultLF1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLF1, $sqloop );
			$forumdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $forumid != $forumdata["fid"] )
	{
		return array( "success" => FALSE, "errmsg" => "No matching forum for forumid '$forumid'!" );
	}
	
	$forumdata["success"] = TRUE;
	
	return $forumdata;
}

function LoadForums()
{
	require( "config.php" );
	
	$query = "select * from forums";
	$resultLFs1 = mysql_query( $query ) or die( "Query '$query' failed for resultLFs1 in common.php : " . mysql_error() );
	
	$forumsdata = array();
	$forumsdata[0] = 0;
	while ( $line = mysql_fetch_array( $resultLFs1, MYSQL_ASSOC ) )
	{
		$forumsdata[0]++;
		$forumsdata[$forumsdata[0]] = array();
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLFs1, $sqloop );
			$forumsdata[$forumsdata[0]][$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	$forumsdata["success"] = TRUE;
	
	return $forumsdata;
}

function LoadForumByForumname( $forumname )
{
	require( "config.php" );
	
	if ( trim( $forumname ) == NULL || strlen( $forumname ) <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid forumname - '$forumname'!" );
	}
	
	$query = "select * from forums where fname='$forumname'";
	$resultLFBF1 = mysql_query( $query ) or die( "Query '$query' failed for resultLFBF1 in common.php : " . mysql_error() );
	
	$forumdata = array();
	while ( $line = mysql_fetch_array( $resultLFBF1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLFBF1, $sqloop );
			$forumdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( strcasecmp( $forumname, $forumdata["fname"] ) )
	{
		/* Try it without spaces (for emails).  --Kris */
		$query = "select fname from forums";
		$resultLFBF2 = mysql_query( $query ) or die( "Query '$query' failed for resultLFBF2 in common.php : " . mysql_error() );
		
		while ( $line = mysql_fetch_array( $resultLFBF2, MYSQL_ASSOC ) )
		{
			$found = FALSE;
			foreach ( $line as $col_value )
			{
				if ( strcasecmp( $forumname, ParseChars( $col_value, array( 1 => " " ) ) ) == 0 )
				{
					$found = TRUE;
					break;
				}
			}
			if ( $found == TRUE )
			{
				break;
			}
		}
		
		if ( $found == TRUE )
		{
			$query = "select * from forums where fname='$col_value'";
			$resultLFBF1b = mysql_query( $query ) or die( "Query '$query' failed for resultLFBF1b in common.php : " . mysql_error() );
			
			$forumdata = array();
			while ( $line = mysql_fetch_array( $resultLFBF1b, MYSQL_ASSOC ) )
			{
				$sqloop = 0;
				foreach ( $line as $col_value )
				{
					$fieldname = mysql_field_name( $resultLFBF1b, $sqloop );
					$forumdata[$fieldname] = $col_value;
					$sqloop++;
				}
			}
		}
		else
		{
			return array( "success" => FALSE, "errmsg" => "No matching forum for forumname '$forumname'!" );
		}
	}
	
	$forumdata["success"] = TRUE;
	
	return $forumdata;
}

/* This function parses one or more characters out of a string.  --Kris */
function ParseChars( $instring, $parsechars = array( 1 => " " ) )
{
	if ( $instring == NULL )
	{
		return NULL;
	}
	
	$outstring = NULL;
	for ( $parseloop = 0; $parseloop < $instring; $parseloop++ )
	{
		$parsefound = FALSE;
		foreach ( $parsechars as $pkey => $pval )
		{
			if ( strcmp( $instring{$parseloop}, $pval ) == 0 )
			{
				$parsefound = TRUE;
				break;
			}
		}
		if ( $parsefound == TRUE )
		{
			continue;
		}
		else
		{
			$outstring .= $instring{$parseloop};
		}
	}
	
	return $outstring;
}

function LoadTopic( $topicid )
{
	require( "config.php" );
	
	if ( !is_numeric( $topicid ) || trim( $topicid ) == NULL || $topicid <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid topicid - '$topicid'!" );
	}
	
	$query = "select * from topics where tid='$topicid'";
	$resultLT1 = mysql_query( $query ) or die( "Query '$query' failed for resultLT1 in common.php : " . mysql_error() );
	
	$topicdata = array();
	while ( $line = mysql_fetch_array( $resultLT1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLT1, $sqloop );
			$topicdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $topicid != $topicdata["tid"] )
	{
		return array( "success" => FALSE, "errmsg" => "No matching topic for topicid '$topicid'!" );
	}
	
	$topicdata["success"] = TRUE;
	
	return $topicdata;
}

function LoadPosts( $topicid )
{
	require( "config.php" );
	
	if ( !is_numeric( $topicid ) || trim( $topicid ) == NULL || $topicid <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid topicid - '$topicid'!" );
	}
	
	$query = "select * from posts where tid='$topicid' AND ( pstatus='ACTIVE' OR pstatus='NEW' ) order by ptimestamp ASC";
	$resultLPo1 = mysql_query( $query ) or die( "Query '$query' failed for resultLPo1 in common.php : " . mysql_error() );
	
	$postsdata = array();
	$postsdata[0] = 0;
	while ( $line = mysql_fetch_array( $resultLPo1, MYSQL_ASSOC ) )
	{
		$postsdata[0]++;
		$postsdata[$postsdata[0]] = array();
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLPo1, $sqloop );
			$postsdata[$postsdata[0]][$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $postsdata[0] == 0 )
	{
		return array( "success" => FALSE, "errmsg" => "No matching topic for topicid '$topicid'!" );
	}
	
	$postsdata["success"] = TRUE;
	
	return $postsdata;
}

function LoadPost( $postid )
{
	require( "config.php" );
	
	if ( !is_numeric( $postid ) || trim( $postid ) == NULL || $postid <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid postid - '$postid'!" );
	}
	
	$query = "select * from posts where pid='$postid' AND ( pstatus='ACTIVE' OR pstatus='NEW' ) order by ptimestamp ASC";
	$resultLPos1 = mysql_query( $query ) or die( "Query '$query' failed for resultLPos1 in common.php : " . mysql_error() );
	
	$postdata = array();
	while ( $line = mysql_fetch_array( $resultLPos1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLPos1, $sqloop );
			$postdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $postdata["pid"] != $postid )
	{
		return array( "success" => FALSE, "errmsg" => "No matching post for postid '$postid'!" );
	}
	
	$postdata["success"] = TRUE;
	
	return $postdata;
}

/* Using '|' delination.  --Kris */
function GetWords( $intext )
{
	$outstring = array();
	$wordfound = FALSE;
	$outstring[0] = 0;  /* Number of words found.  --Kris */
	
	for ( $parseloop = 0; $parseloop < strlen( $intext ); $parseloop++ )
	{
		$breakfound = FALSE;
		if ( strcmp( $intext{$parseloop}, "|" ) == 0 )
		{
			$breakfound = TRUE;
		}
		
		if ( $breakfound == TRUE && $wordfound == FALSE )
		{
			continue;
		}
		else if ( $breakfound == FALSE )
		{
			if ( $wordfound == FALSE )
			{
				$outstring[0]++;
			}
			$wordfound = TRUE;
			$tmpnum = $outstring[0];
			$outstring[$tmpnum] .= $intext{$parseloop};
			continue;
		}
		else if ( $breakfound == TRUE && $wordfound == TRUE )
		{
			$wordfound = FALSE;
			continue;
		}
	}
	
	return $outstring;
}

function IsSubscribed( $profiledata, $fid )
{
	$userdata = array();
	$userdata = LoadUser( $profiledata["userid"] );
	
	/* DEBUG ONLY - Assume admins are subscribed to all forums.  --Kris */
	/*$isadmin = CheckUserAdmin();
	if ( $isadmin == TRUE )
	{
		return TRUE;
	}*/
	
	$subforums = array();
	$subforums = GetWords( $profiledata["subscribedforumids"] );
	
	$subscribed = FALSE;
	foreach ( $subforums as $subkey => $subval )
	{
		if ( $subkey == 0 )
		{
			continue;
		}
		
		if ( $subval == $fid )
		{
			$subscribed = TRUE;
			break;
		}
	}
	
	return $subscribed;
}

function IsInvited( $profiledata, $fid )
{
	$userdata = array();
	$userdata = LoadUser( $profiledata["userid"] );
	
	$isadmin = CheckUserAdmin();
	
	/* Assume admins are invited to all forums.  --Kris */
	if ( $isadmin == TRUE )
	{
		return TRUE;
	}
	
	$invforums = array();
	$invforums = GetWords( $profiledata["invitedforumids"] );
	
	$invited = FALSE;
	foreach ( $invforums as $invkey => $invval )
	{
		if ( $invkey == 0 )
		{
			continue;
		}
		
		if ( $invval == $fid )
		{
			$invited = TRUE;
			break;
		}
	}
	
	return $invited;
}

/* If no forum specified, check all active forums.  --Kris */
function IsModerator( $profiledata, $fid = NULL )
{
	$moderator = FALSE;
	
	if ( $fid == NULL )
	{
		$allforums = array();
		$allforums = LoadForums();
		
		foreach ( $allforums as $akey => $aval )
		{
			if ( $akey == 0 )
			{
				continue;
			}
			
			$subusers = array();
			$subusers = GetWords( $aval["fmoderatoruserids"] );
			
			foreach ( $subusers as $skey => $sval )
			{
				if ( $skey == 0 )
				{
					continue;
				}
				
				if ( $sval == $profiledata["userid"] )
				{
					$moderator = TRUE;
					break;
				}
			}
		}
	}
	else
	{
		$forumdata = array();
		$forumdata = LoadForum( $fid );
		
		$subusers = array();
		$subusers = GetWords( $forumdata["fmoderatoruserids"] );
		
		foreach ( $subusers as $skey => $sval )
		{
			if ( $skey == 0 )
			{
				continue;
			}
			
			if ( $sval == $profiledata["userid"] )
			{
				$moderator = TRUE;
				break;
			}
		}
	}
	
	return $moderator;
}

function IsBanned( $profiledata, $fid )
{
	$userdata = array();
	$userdata = LoadUser( $profiledata["userid"] );
	
	/* Assume admins are moderator to all forums.  --Kris */
	/*if ( $isadmin == TRUE )
	{
		return TRUE;
	}*/
	
	$subforums = array();
	$subforums = GetWords( $profiledata["bannedforumids"] );
	
	$banned = FALSE;
	foreach ( $subforums as $subkey => $subval )
	{
		if ( $subkey == 0 )
		{
			continue;
		}
		
		if ( $subval == $fid )
		{
			$banned = TRUE;
			break;
		}
	}
	
	return $banned;
}

function GetModerators( $fid )
{
	$moderators = array();
	$moderators[0] = 0;
	
	$profiles = array();
	$profiles = LoadProfiles();
	
	foreach ( $profiles as $pkey => $pval )
	{
		if ( $pkey == 0 )
		{
			continue;
		}
		
		$modids = array();
		$modids = GetWords( $profiles[$pkey]["moderatedforumids"] );
		
		$modfound = FALSE;
		foreach ( $modids as $modkey => $modval )
		{
			if ( $modkey == 0 )
			{
				continue;
			}
			
			if ( $modval == $fid )
			{
				$modfound = TRUE;
				break;
			}
		}
		
		if ( $modfound == TRUE )
		{
			$moderators[0]++;
			$moderators[$moderators[0]] = $profiles[$pkey]["userid"];
		}
	}
	
	return $moderators;
}

function GetDigestPref( $profiledata, $fid )
{
	if ( !IsSubscribed( $profiledata, $fid ) )
	{
		return NULL;
	}
	
	$userdata = array();
	$userdata = LoadUser( $profiledata["userid"] );
	
	$subforums = array();
	$subforums = GetWords( $profiledata["subscribedforumids"] );
	
	foreach ( $subforums as $subkey => $subval )
	{
		if ( $subkey == 0 )
		{
			continue;
		}
		
		if ( $subval == $fid )
		{
			break;
		}
	}
	
	$digpref = array();
	$digpref = GetWords( $profiledata["forumdigestprefs"] );
	
	return $digpref[$subkey];
}

/*
 * A very simple check.
 * The software relies on the subscribedforumids and forumdigestprefs columns in the 
 * profiles table to match-up.  For example, if you have "3|12|7" for subscribedforumids and 
 * "1|0|3" for forumdigestprefs, then the software interprets the following meaning:
 * The user is subscribed to 3 forums; subscription #1 [1] is to the forum with fid value of 3, 
 * and the user's email digest preference for that forum is digestpref #1 [1], which has a value 
 * of 1 (receive all emails).  Following this logic, forum ID 12 has a digestpref of 0 (receive 
 * no emails), and forum ID 7 has a digestpref of 3 (receive email transcript of first message 
 * and email notification of first reply).  Obviously, if, for some reason, something is added 
 * or removed in one of those columns of a row but not the other, then any numbers following 
 * that will not be matched-up, and this will cause the user's subscription and email digest 
 * preferences to get all out of whack, and potentially cause other unpredictable symptoms.
 *
 * Therefore, this function is VERY important, even though it should never have to be used if 
 * the database is being maintained properly and there are no unanticipated disasters.  Basically, 
 * this function just checks to see if each column has the same number of entries (in the above 
 * example, they both have 3).  If they don't (i.e. if one is something like "3|12|7|4" and the 
 * other is something like "0|2"), then the script assumes all the data is corrupted and wipes it 
 * clean.  This way, all that will happen is that the user will lose all of his/her subscriptions 
 * and digest preference settings, both of which are easy enough to replace.  Much better than 
 * having a corrupted set of entries causing unpredictable results that could start to break 
 * other things as well.
 *
 * Wow, such a lengthy explanation for such a tiny little function!
 *
 * --Kris
 * 08.02.2008
 */
function FixCorruptedSubData( $subdata )
{
	if ( $subdata["subforums"][0] != $subdata["digpref"][0] )
	{
		$subdata = array();
		$subdata["subforums"] = array( 0 => 0 );
		$subdata["digpref"] = array( 0 => 0 );
	}
	
	return $subdata;
}

function AddSub( $profiledata, $fid, $digpref )
{
	$userdata = array();
	$userdata = LoadUser( $profiledata["userid"] );
	
	$subdata = array();
	
	$subdata["subforums"] = array();
	$subdata["subforums"] = GetWords( $profiledata["subscribedforumids"] );
	
	$subdata["digpref"] = array();
	$subdata["digpref"] = GetWords( $profiledata["forumdigestprefs"] );
	
	/* Just in case the database counts get corrupted somehow and don't match.  --Kris */
	$subdata = FixCorruptedSubData( $subdata );
	
	/* If already subscribed, just update the digpref.  --Kris */
	$subfound = FALSE;
	foreach ( $subdata["subforums"] as $subkey => $subval )
	{
		if ( $subkey == 0 )
		{
			continue;
		}
		
		if ( $subval == $fid )
		{
			$subfound = TRUE;
			break;
		}
	}
	
	if ( $subfound == TRUE )
	{
		$subdata["digpref"][$subkey] = $digpref;
	}
	else
	{
		$subdata["subforums"][0]++;
		$subdata["subforums"][$subdata["subforums"][0]] = $fid;
		
		$subdata["digpref"][0]++;
		$subdata["digpref"][$subdata["digpref"][0]] = $digpref;
	}
	
	return $subdata;
}

function RemoveSub( $profiledata, $fid )
{
	$userdata = array();
	$userdata = LoadUser( $profiledata["userid"] );
	
	$subdata = array();
	
	$subdata["subforums"] = array();
	$subdata["subforums"] = GetWords( $profiledata["subscribedforumids"] );
	
	$subdata["digpref"] = array();
	$subdata["digpref"] = GetWords( $profiledata["forumdigestprefs"] );
	
	/* Just in case the database counts get corrupted somehow and don't match.  --Kris */
	$subdata = FixCorruptedSubData( $subdata );
	
	/* If it was corrupted and wiped clean, then we have nothing left to remove.  --Kris */
	if ( $subdata["subforums"][0] == 0 )
	{
		return $subdata;
	}
	
	$newsubdata = array();
	$newsubdata["subforums"] = array();
	$newsubdata["subforums"][0] = 0;
	$newsubdata["digpref"] = array();
	$newsubdata["digpref"][0] = 0;
	
	foreach ( $subdata["subforums"] as $subkey => $subval )
	{
		if ( $subkey == 0 )
		{
			continue;
		}
		else if ( $subval == $fid )
		{
			continue;
		}
		
		$newsubdata["subforums"][0]++;
		$newsubdata["digpref"][0]++;
		
		$newsubdata["subforums"][$newsubdata["subforums"][0]] = $subval;
		$newsubdata["digpref"][$newsubdata["digpref"][0]] = $subdata["digpref"][$subkey];
	}
	
	return $newsubdata;
}

function EnterForum( $fid, $userdata, $forumdata, $profiledata )
{
	require( "config.php" );
	
	$subscribed = IsSubscribed( $profiledata, $fid );
	
	if ( $subscribed == FALSE && $forumdata["ispublic"] == 3 && strcasecmp( $thispage, "subscribe.php" ) )
	{
		GenerateHeader( "EverList - Forum", TRUE );
		$topdata = array();
		$topdata = GenerateTop( $userdata );
		
		print "<b style=\"color: red\">";
		print "This forum is not open to the public!  You must subscribe in order to view/post messages.";
		print "</b>";
		print "<br /><br />";
		
		if ( $forumdata["subscriptionpolicy"] == 0 )
		{
			print "This forum is not currently accepting new subscriptions.";
		}
		else if ( $forumdata["subscriptionpolicy"] == 1 || $forumdata["subscriptionpolicy"] == 2 )
		{
			if ( $userdata["authstatus"] == 1 )
			{
				print "<a href=\"subscribe.php?fid=$fid\">Click HERE to Subscribe!</a>";
			}
			else
			{
				print "<a href=\"login.php\">Login</a>";
			}
		}
		else if ( $forumdata["subscriptionpolicy"] == 3 )
		{
			print "You must be invited in order to subscribe to this forum.<br />";
			print "If you believe you have been invited, check your inbox for an invitation email and follow the instructions therein.";
		}
		
		GenerateFooter();
		die();
	}
	
	$query = "update profiles set currentforumid='$fid' where userid='" . $userdata["userid"] . "'";
	$resultEF1 = mysql_query( $query ) or die( "Query '$query' failed for resultEF1 in common.php : " . mysql_error() );
	
	return TRUE;
}

function CheckPostLimitReached( $forumdata, $userdata )
{
	/* Exempt admins from all post limits.  --Kris */
	if ( $isadmin == TRUE )
	{
		return FALSE;
	}
	
	$hourseconds = pow( 60, 2 );
	
	$dayseconds = $hourseconds * 24;
	
	$query = "select tid from topics where fid='" . $forumdata["fid"] . "'";
	$resultCPLR1 = mysql_query( $query ) or die( "Query '$query' failed for resultCPLR1 in common.php : " . mysql_error() );
	
	$forumtopics = array();
	$forumtopics[0] = 0;
	while ( $line = mysql_fetch_array( $resultCPLR1, MYSQL_ASSOC ) )
	{
		$forumtopics[0]++;
		$forumtopics[$forumtopics[0]] = array();
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultCPLR1, $sqloop );
			$forumtopics[$forumtopics[0]][$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $forumdata["maxpostsperhour"] > 0 )
	{
		$hourposts = 0;
		$hourago = time() - $hourseconds;
		
		for ( $tloop = 1; $tloop <= $forumtopics[0]; $tloop++ )
		{
			$query = "select pid from posts where tid='" . $forumtopics[$tloop]["tid"] . "' AND ptimestamp>='" . $hourago . "' AND createdbyuserid='" . $userdata["userid"] . "'";
			$resultCPLR2 = mysql_query( $query ) or die( "Query '$query' failed for resultCPLR2 in common.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resultCPLR2, MYSQL_ASSOC ) )
			{
				$hourposts++;
			}
		}
		
		if ( $hourposts >= $forumdata["maxpostsperhour"] )
		{
			return 1;
		}
	}
	
	if ( $forumdata["maxpostsperday"] > 0 )
	{
		$dayposts = 0;
		$dayago = time() - $dayseconds;
		
		for ( $tloop = 1; $tloop <= $forumtopics[0]; $tloop++ )
		{
			$query = "select pid from posts where tid='" . $forumtopics[$tloop]["tid"] . "' AND ptimestamp>='" . $dayago . "' AND createdbyuserid='" . $userdata["userid"] . "'";
			$resultCPLR2 = mysql_query( $query ) or die( "Query '$query' failed for resultCPLR2 in common.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resultCPLR2, MYSQL_ASSOC ) )
			{
				$dayposts++;
			}
		}
		
		if ( $dayposts >= $forumdata["maxpostsperday"] )
		{
			return 2;
		}
	}
	
	return 0;
}

function NewPost( $tid = NULL, $fid = NULL )
{
	$topicdata = array();
	$topicdata = LoadTopic( $tid );
	
	?>
	<form name="postreply" action="submitpost.php" method="POST">
	
	<?php
	
	/* If we're posting a new topic.  --Kris */
	if ( $topicdata["success"] == FALSE )
	{
		$buttontext = "Post New Topic!";
		
		?>
		<h3>Post a New Topic:</h3>
		<b>Subject:</b> &nbsp;
		<input type="text" name="topicname" size="90" maxlength="70" />
		<input type="hidden" name="newtopic" value="1" />
		<input type="hidden" name="fid" value="<?php print $fid; ?>" />
		<br />
		<br />
		<?php
	}
	else
	{
		$buttontext = "Post Reply!";
		
		?>
		<h3>Post a Reply:</h3>
		<input type="hidden" name="newtopic" value="0" />
		<?php
	}
	
	?>
	<input type="hidden" name="formstage" value="1" />
	<input type="hidden" name="posttid" value="<?php print $tid; ?>" />
	
	<textarea name="postbody" rows="5" cols="30"></textarea>
	
	<br />
	
	<input type="checkbox" name="excludemessage" value="1" /> 
	<a class="info">Exclude message text from email<font size="-1" color="green"> <sup>[?]</sup></font><span>
	<b style="color: red; font-size: 12pt">WARNING:</b>
	<br />
	Your post will be emailed to every subscribed user who has opted to receive digest emails 
	for this forum.
	<br />
	<br />
	Many email clients, including Gmail and Outlook, have very limited 
	support for rich-text HTML formatting.  Though basic font styling and images generally 
	have universal support, please be aware that excessively "fancy" formatting of your 
	text may result in your post getting "garbled" or filtered by some recipients with 
	incompatible email clients.
	<br />
	<br />
	If you wish to use a lot of formatting anyway and are concerned that some 
	email clients might garble it up, check the box below to have the email contain only a 
	direct link to your post on this website, without the message text itself.  Please note 
	that this link will be included in every digest email anyway, regardless of whether or not the 
	message exclusion box is checked.
	</span></a>
	
	<br />
	<br />
	
	<input type="submit" name="submitform" value="<?php print $buttontext; ?>" />
	
	</form>
	
	<?php
}

/*
 * Hotmail inserts a lot of crap into the HTML message body!  It uses a bunch of escape 
 * encoding, except that everything is encoded with "=" instead of "%".  Furthermore, 
 * it tries to pass a forced line-wrap by ending each line with a "=" by itself followed 
 * by a plain-text line break.  I banged my head against a wall for two hours until I 
 * finally managed to figure out where all that garbled text was coming from.  I had to 
 * write this hackish little function convert the encoding and filter-out the garbage.
 * I hate Microsoft....
 *
 * --Kris
 * 08.06.2008
 */
function ParseHotmail( $bodytext )
{
	$bodytext = str_replace( "=" . chr(13), "", $bodytext );
	$bodytextnew = NULL;
	for ( $parseloop = 0; $parseloop < strlen( $bodytext ); $parseloop++ )
	{
		if ( strcmp( $bodytext{$parseloop}, chr(10) ) == 0 
			|| strcmp( $bodytext{$parseloop}, chr(13) ) == 0 
			|| strcmp( $bodytext{$parseloop}, "\n" ) == 0 
			|| strcmp( $bodytext{$parseloop}, "\r" ) == 0 )
		{
			continue;
		}
		else
		{
			$bodytextnew .= $bodytext{$parseloop};
		}
	}
	$bodytext = $bodytextnew;
	$bodytext = urldecode( str_replace( "=", "%", $bodytext ) );
	
	return $bodytext;
}
