<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

foreach ( $_POST as $postvar => $postval )
{
	$$postvar = $postval;
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

$isadmin = CheckUserAdmin();

GenerateHeader( "EverList - Forum Moderation", TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$profiledata = array();
$profiledata = $topdata["profiledata"];

if ( IsModerator( $profiledata ) == FALSE && $isadmin == FALSE )
{
	print "You are not the moderator of any forums.";
	GenerateBottom();
	GenerateFooter();
	die();
}
/* Admins automatically have moderator access to all forums.  --Kris */
else if ( $isadmin == TRUE )
{
	$allforums = array();
	$allforums = LoadForums();
	
	$moderations = array();
	$moderations[0] = $allforums[0];
	
	foreach ( $allforums as $allkey => $allval )
	{
		if ( $allkey == 0 || !is_numeric( $allkey ) )
		{
			continue;
		}
		
		$moderations[$allkey] = $allval["fid"];
	}
}
else
{
	$allforums = array();
	$allforums = LoadForums();
	
	$moderations = array();
	$moderations[0] = 0;
	
	foreach ( $allforums as $allkey => $allval )
	{
		if ( $allkey == 0 || !is_numeric( $allkey ) )
		{
			continue;
		}
		
		if ( IsModerator( $profiledata, $allval["fid"] ) == TRUE )
		{
			$moderations[0]++;
			$moderations[$moderations[0]] = $allval["fid"];
		}
	}
}

?>
<table border="0" cellpadding="0" cellspacing="0" width="750">
<tr>
<td><img src="images/space1px.gif" width="15" height="1" alt="" /></td>
<td>
<table border="0" cellpadding="0" cellspacing="0">
<tr>

<td><img src="images/space1px.gif" width="20" height="1" alt="" /></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="control_panel.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Your Profile</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="changepassword.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Change Password</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="subscriptions.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Subscriptions</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<?php
if ( IsModerator( $profiledata ) 
	|| $isadmin == TRUE )
{
	?>
	<td align="right"><img src="images/subsel_left.gif" width="7" height="17" alt="" /></td>
	<td bgcolor="#90EE90"><a href="#"><span style="font-size: 8pt; color: darkgreen; font-family: Courier New"><b>Manage Forums</b></span></a></td>
	<td align="left"><img src="images/subsel_right.gif" width="7" height="17" alt="" /></td>
	
	<?php
}

if ( $isadmin == TRUE )
{
	?>
	<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
	<td bgcolor="#40AA40"><a href="manageusers.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Manage Users</b></span></a></td>
	<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
	
	<?php
}

?>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="735">
<tr>
<td width="8"><img src="images/sub_topleft.gif" width="8" height="8" alt="" /></td>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="716" height="1" alt="" /></td>
<td width="11"><img src="images/sub_topright.gif" width="11" height="8" alt="" /></td>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="735">

<tr>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" alt="" /></td>
<td bgcolor="#90EE90" align="center">

<?php

if ( $moderations[0] > 0 )
{
	if ( trim( $msg ) != NULL )
	{
		print "<h3>$msg</h3>";
	}
	else if ( $formstage == 1 )
	{
		foreach ( $_POST as $postvar => $postval )
		{
			if ( strcasecmp( $postvar, "formstage" ) == 0 
				|| strcasecmp( $postvar, "submitform" ) == 0 )
			{
				continue;
			}
			
			if ( $postval == 0 )
			{
				continue;
			}
			else if ( $postval == 1 )
			{
				$query = "update pendingsubs set status='APPROVED' where psid='$postvar'";
				$resulttl2 = mysql_query( $query ) or die( "Query '$query' failed for resulttl2 in moderate.php : " . mysql_error() );
				
				$query = "select userid, fid, digpref from pendingsubs where psid='$postvar'";
				$resulttl3 = mysql_query( $query ) or die( "Query '$query' failed for resulttl3 in moderate.php : " . mysql_error() );
				
				while ( $line = mysql_fetch_array( $resulttl3, MYSQL_ASSOC ) )
				{
					$sqloop = 0;
					foreach ( $line as $col_value )
					{
						$fieldname = mysql_field_name( $resulttl3, $sqloop );
						$$fieldname = $col_value;
						$sqloop++;
					}
				}
				
				$psforum = array();
				$psforum = LoadForum( $fid );
				
				$psuser = array();
				$psuser = LoadUser( $userid );
				
				$psprofile = array();
				$psprofile = LoadProfile( $userid );
				
				$subdata = array();
				$subdata = AddSub( $psprofile, $fid, $digpref );
				
				$insertfstring = NULL;
				$insertdstring = NULL;
				for ( $iloop = 1; $iloop <= $subdata["subforums"][0]; $iloop++ )
				{
					$insertfstring .= strval( $subdata["subforums"][$iloop] );
					$insertdstring .= strval( $subdata["digpref"][$iloop] );
					
					if ( $iloop < $subdata["subforums"][0] )
					{
						$insertfstring .= "|";
						$insertdstring .= "|";
					}
				}
				
				$query = "update profiles set subscribedforumids='$insertfstring', ";
				$query .= "forumdigestprefs='$insertdstring' ";
				$query .= "where prid='" . $psprofile["prid"] . "'";
				$resulttl4 = mysql_query( $query ) or die( "Query '$query' failed for resulttl4 in moderate.php : " . mysql_error() );
				
				$subject = "EverList Subscription Approved!";
				
				$msgbody = "Congratulations!  Your subscription request for the forum, ";
				$msgbody .= "<a href=\"$siteurl/viewforum.php?fid=$fid\">" . $psforum["fname"] . "</a>, ";
				$msgbody .= "has been approved!";
				
				$mailresult = mail( $psuser["email"], $subject, $msgbody, 
					// Email header
					"From: " . $mailfrom . "\r\n" 
					. "Reply-To: " . $mailfrom . "\r\n" 
					. "Content-type: text/html\r\n" 
					. "X-mailer: PHP/" . phpversion() );
			}
			else if ( $postval == 2 )
			{
				$query = "update pendingsubs set status='REJECTED' where psid='$postvar'";
				$resulttl5 = mysql_query( $query ) or die( "Query '$query' failed for resulttl5 in moderate.php : " . mysql_error() );
				
				$query = "select userid, fid, digpref from pendingsubs where psid='$postvar'";
				$resulttl6 = mysql_query( $query ) or die( "Query '$query' failed for resulttl6 in moderate.php : " . mysql_error() );
				
				while ( $line = mysql_fetch_array( $resulttl6, MYSQL_ASSOC ) )
				{
					$sqloop = 0;
					foreach ( $line as $col_value )
					{
						$fieldname = mysql_field_name( $resulttl6, $sqloop );
						$$fieldname = $col_value;
						$sqloop++;
					}
				}
				
				$psforum = array();
				$psforum = LoadForum( $fid );
				
				$psuser = array();
				$psuser = LoadUser( $psuser );
				
				$subject = "EverList Subscription DENIED!";
				
				$msgbody = "We're sorry, but your subscription request for the forum, ";
				$msgbody .= "<a href=\"$siteurl/viewforum.php?fid=$fid\">" . $psforum["fname"] . "</a>, ";
				$msgbody .= "has been rejected!";
				
				$mailresult = mail( $psuser["email"], $subject, $msgbody, 
					// Email header
					"From: " . $mailfrom . "\r\n" 
					. "Reply-To: " . $mailfrom . "\r\n" 
					. "Content-type: text/plain\r\n" 
					. "X-mailer: PHP/" . phpversion() );
			}
		}
		
		print "<h3>Subscriptions updated!</h3>";
	}
	else if ( $formstage == 2 )
	{
		foreach ( $_POST as $postvar => $postval )
		{
			if ( strcasecmp( $postvar, "formstage" ) == 0 
				|| strcasecmp( $postvar, "submitform" ) == 0 )
			{
				continue;
			}
			
			if ( $postval == 0 )
			{
				continue;
			}
			else if ( $postval == 1 )
			{
				$dowhat = substr( $postvar, 0, 3 );
				$tofid = NULL;
				$touserid = NULL;
				
				$dashfound = FALSE;
				for ( $parseloop = 3; $parseloop < strlen( $postvar ); $parseloop++ )
				{
					if ( strcmp( $postvar{$parseloop}, "-" ) == 0 )
					{
						$dashfound = TRUE;
						continue;
					}
					else if ( $dashfound == FALSE )
					{
						$tofid .= $postvar{$parseloop};
					}
					else
					{
						$touserid .= $postvar{$parseloop};
					}
				}
				
				$subprof = array();
				$subprof = LoadProfile( $touserid );
				
				if ( strcasecmp( $dowhat, "uns" ) == 0 )
				{
					$subdata = array();
					$subdata = RemoveSub( $subprof, $tofid );
					
					$insertfstring = NULL;
					$insertdstring = NULL;
					for ( $iloop = 1; $iloop <= $subdata["subforums"][0]; $iloop++ )
					{
						$insertfstring .= strval( $subdata["subforums"][$iloop] );
						$insertdstring .= strval( $subdata["digpref"][$iloop] );
						
						if ( $iloop < $subdata["subforums"][0] )
						{
							$insertfstring .= "|";
							$insertdstring .= "|";
						}
					}
					
					$query = "update profiles set subscribedforumids='$insertfstring', ";
					$query .= "forumdigestprefs='$insertdstring' ";
					$query .= "where prid='" . $subprof["prid"] . "'";
					$resulttl7 = mysql_query( $query ) or die( "Query '$query' failed for resulttl7 in moderate.php : " . mysql_error() );
				}
				else if ( strcasecmp( $dowhat, "ban" ) == 0 )
				{
					$subdata = array();
					$subdata = RemoveSub( $subprof, $tofid );
					
					$insertfstring = NULL;
					$insertdstring = NULL;
					for ( $iloop = 1; $iloop <= $subdata["subforums"][0]; $iloop++ )
					{
						$insertfstring .= strval( $subdata["subforums"][$iloop] );
						$insertdstring .= strval( $subdata["digpref"][$iloop] );
						
						if ( $iloop < $subdata["subforums"][0] )
						{
							$insertfstring .= "|";
							$insertdstring .= "|";
						}
					}
					
					$query = "update profiles set subscribedforumids='$insertfstring', ";
					$query .= "forumdigestprefs='$insertdstring' ";
					$query .= "where prid='" . $subprof["prid"] . "'";
					$resulttl8 = mysql_query( $query ) or die( "Query '$query' failed for resulttl8 in moderate.php : " . mysql_error() );
					
					$query = "update profiles set bannedforumids=CONCAT_WS('|',bannedforumids,'$tofid') ";
					$query .= "where prid='" . $subprof["prid"] . "'";
					$resulttl9 = mysql_query( $query ) or die( "Query '$query' failed for resulttl9 in moderate.php : " . mysql_error() );
				}
				else
				{
					/* This shouldn't happen, but just in case....  --Kris */
					print "<h3 style=\"color: red\">ERROR!  Unknown action '$dowhat' on postvar '$postvar', postval '$postval'!  Please report this programming error to kris.craig@gmail.com immediately!</h3>";
				}
		
				print "<h3>Subscriptions updated!</h3>";
			}
		}
	}
	else if ( $formstage == 3 )
	{
		$forumsdata = array();
		$forumsdata = LoadForums();
		
		foreach ( $forumsdata as $fkey => $fval )
		{
			$tofid = $fval["fid"];
			
			if ( $_POST["pub$tofid"] == NULL 
				|| !is_numeric( $_POST["pub$tofid"] ) )
			{
				$_POST["pub$tofid"] = "0";
			}
			
			if ( $_POST["clo$tofid"] == NULL 
				|| !is_numeric( $_POST["clo$tofid"] ) )
			{
				$_POST["clo$tofid"] = "0";
			}
			
			if ( $_POST["vis$tofid"] == NULL 
				|| !is_numeric( $_POST["vis$tofid"] ) )
			{
				$_POST["vis$tofid"] = "0";
			}
			
			if ( $_POST["hrm$tofid"] == NULL 
				|| !is_numeric( $_POST["hrm$tofid"] ) )
			{
				$_POST["hrm$tofid"] = "0";
			}
			
			if ( $_POST["dam$tofid"] == NULL 
				|| !is_numeric( $_POST["dam$tofid"] ) )
			{
				$_POST["dam$tofid"] = "0";
			}
		}
		
		foreach ( $_POST as $postvar => $postval )
		{
			if ( strcasecmp( $postvar, "formstage" ) == 0 
				|| strcasecmp( $postvar, "submitform" ) == 0 )
			{
				continue;
			}
			
			$dowhat = substr( $postvar, 0, 3 );
			$tofid = substr( $postvar, 3, strlen( $postvar ) - 3 );
			
			if ( strcasecmp( $dowhat, "clo" ) == 0 
				|| strcasecmp( $dowhat, "pub" ) == 0 
				|| strcasecmp( $dowhat, "vis" ) == 0 )
			{
				if ( trim( $postval ) == NULL )
				{
					$postval = 0;
				}
			}
			else
			{
				if ( trim( $postval ) == NULL )
				{
					$postval = 0;
				}
				else if ( !is_numeric( $postval ) )
				{
					continue;
				}
			}
			
			$sqlvar = array();
			$sqlvar["pub"] = "ispublic";
			$sqlvar["clo"] = "isclosed";
			$sqlvar["vis"] = "fvisible";
			$sqlvar["hrm"] = "maxpostsperhour";
			$sqlvar["dam"] = "maxpostsperday";
			
			$query = "update forums set " . $sqlvar[$dowhat] . "='$postval' where fid='$tofid'";
			$resulttl10 = mysql_query( $query ) or die( "Query '$query' failed for resulttl10 in moderate.php : " . mysql_error() );
		}
		
		print "<h3>Forum settings updated!</h3>";
	}
	else if ( $formstage == 4 )
	{
		if ( trim( $s_fname ) == NULL )
		{
			print "<h3 style=\"color: red\">You must specify a forum name!</h3>";
			$formstage = 0;
		}
		
		$s_fname = addslashes( $s_fname );
		
		$query = "select fname from forums where fname='$s_fname'";
		$resulttl12 = mysql_query( $query ) or die( "Query '$query' failed for resulttl12 in moderate.php : " . mysql_error() );
		
		$dupfound = FALSE;
		while ( $line = mysql_fetch_array( $resulttl12, MYSQL_ASSOC ) )
		{
			$dupfound = TRUE;
			break;
		}
		
		if ( $dupfound == TRUE )
		{
			print "<h3 style=\"color: red\">A forum by that name already exists!</h3>";
			$formstage = 0;
		}
	}
	
	if ( $formstage == 4 )
	{
		$cur_timestamp = time();
		
		$moderatoruserids = NULL;
		foreach ( $_POST as $postvar => $postval )
		{
			if ( strcasecmp( substr( $postvar, 0, 5 ), "s_mod" ) == 0 )
			{
				if ( $moderatoruserids != NULL )
				{
					$moderatoruserids .= "|";
				}
				
				$moderatoruserids .= substr( $postvar, 5, strlen( $postvar ) - 5 );
			}
		}
		
		if ( trim( $s_maxpostsperday ) == NULL || !is_numeric( $s_maxpostsperday ) )
		{
			$s_maxpostsperday = 0;
		}
		if ( trim( $s_maxpostsperhour ) == NULL || !is_numeric( $s_maxpostsperhour ) )
		{
			$s_maxpostsperhour = 0;
		}
		
		$query = "insert into forums values ( NULL, '$s_fname', ";
		$query .= "'" . addslashes( $s_fdescription ) . "', '$s_ispublic', '$s_isclosed', ";
		$query .= "'$s_subscriptionpolicy', '" . $userdata["userid"] . "', ";
		$query .= "'$moderatoruserids', '$cur_timestamp', '$s_fvisible', ";
		$query .= "'$s_fdigestdefault', '$s_maxpostsperday', '$s_maxpostsperhour' )";
		$resulttl13 = mysql_query( $query ) or die( "Query '$query' failed for resulttl13 in moderate.php : " . mysql_error() );
		
		print "<h3>Forum \"" . stripslashes( $s_fname ) . "\" added successfully!</h3>";
	}
	
	?>
	[ <a href="#pending">Pending Subscriptions</a> | 
	<a href="#existing">Existing Subscriptions</a><?php
	if ( $isadmin == TRUE )
	{
		?> | 
		<a href="#manage">Manage Forums</a> | 
		<a href="#create">Create New Forum</a><?php
	}
	?> ]
	
	<hr width="100%" />
	
	<h3 style="color: #005000" name="pending" id="pending">Pending Subscriptions</h3>
	
	<?php
	
	$query = "select * from pendingsubs where (";
	
	foreach ( $moderations as $modkey => $modval )
	{
		if ( $modkey == 0 )
		{
			continue;
		}
		else if ( $modkey > 1 )
		{
			$query .= " OR";
		}
		
		$query .= " fid='$modval'";
	}
	
	$query .= " ) AND ( status='NEW' OR status='PENDING' )";
	
	$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in moderate.php : " . mysql_error() );
	
	$pendingsubs = array();
	$pendingsubs[0] = 0;
	while ( $line = mysql_fetch_array( $resulttl1, MYSQL_ASSOC ) )
	{
		$pendingsubs[0]++;
		$pendingsubs[$pendingsubs[0]] = array();
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resulttl1, $sqloop );
			$pendingsubs[$pendingsubs[0]][$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $pendingsubs[0] == 0 )
	{
		print "There are currently no pending subscriptions for forums you're moderating.";
	}
	else
	{
		?>
		<form name="pendingform" id="pendingform" action="moderate.php" method="POST">
		
		<input type="hidden" name="formstage" value="1" />
		
		<table border="0" cellspacing="2" cellpadding="2" width="90%">
		<tr>
		<td align="center"><b>No Change</b></td>
		<td align="center"><b>Approve</b></td>
		<td align="center"><b>Reject</b></td>
		<td align="center"><b>Forum</b></td>
		<td align="center"><b>User</b></td>
		</tr>
		
		<?php
		foreach ( $pendingsubs as $pkey => $pval )
		{
			if ( $pkey == 0 )
			{
				continue;
			}
			
			$forumdata = array();
			$forumdata = LoadForum( $pendingsubs[$pkey]["fid"] );
			
			$pendingprofiledata = array();
			$pendingprofiledata = LoadProfile( $pendingsubs[$pkey]["userid"] );
			
			?>
			<tr>
			<td align="center">
			<input type="radio" name="<?php print $pendingsubs[$pkey]["psid"]; ?>" id="<?php print $pendingsubs[$pkey]["psid"]; ?>" value="0" checked />
			</td>
			<td align="center">
			<input type="radio" name="<?php print $pendingsubs[$pkey]["psid"]; ?>" id="<?php print $pendingsubs[$pkey]["psid"]; ?>" value="1" />
			</td>
			<td align="center">
			<input type="radio" name="<?php print $pendingsubs[$pkey]["psid"]; ?>" id="<?php print $pendingsubs[$pkey]["psid"]; ?>" value="2" />
			</td>
			<td align="center">
			<a href="viewforum.php?fid=<?php print $pendingsubs[$pkey]["fid"]; ?>"><?php print $forumdata["fname"]; ?></a>
			</td>
			<td align="center">
			<a href="viewprofile.php?userid=<?php print $pendingsubs[$pkey]["userid"]; ?>"><?php print $pendingprofiledata["fullname"]; ?></a>
			</td>
			</tr>
			
			<?php
		}
		
		?>
		</table>
		
		<br />
		
		<input type="submit" name="submitform" value="Save Changes" />
		
		</form>
		
		<?php
	}
	
	/* Manage existing subscriptions.  --Kris */
	?>
	<hr width="100%" />
	
	<h3 style="color: #005000" name="existing" id="existing">Existing Subscriptions</h3>
	
	<?php
	$profiles = array();
	$profiles = LoadProfiles();
	
	$subs = array();
	$subs[0] = 0;
	
	foreach ( $moderations as $modkey => $modval )
	{
		if ( $modkey == 0 )
		{
			continue;
		}
		
		foreach ( $profiles as $prkey => $prval )
		{
			if ( $prkey == 0 )
			{
				continue;
			}
			
			if ( !IsSubscribed( $prval, $modval ) )
			{
				continue;
			}
			
			$subforum = array();
			$subforum = LoadForum( $modval );
			
			$subuser = array();
			$subuser = LoadUser( $prval["userid"] );
			
			$subs[0]++;
			$subs[$subs[0]] = array();
			
			$subs[$subs[0]]["fid"] = $modval;
			$subs[$subs[0]]["fname"] = $subforum["fname"];
			$subs[$subs[0]]["userid"] = $prval["userid"];
			$subs[$subs[0]]["fullname"] = $prval["fullname"];
			$subs[$subs[0]]["email"] = $subuser["email"];
		}
	}
	
	if ( $subs[0] == 0 )
	{
		print "Nobody is subscribed to any forums you're moderating.";
	}
	else
	{
		?>
		<form name="subsform" id="subsform" action="moderate.php" method="POST">
		
		<input type="hidden" name="formstage" value="2" />
		
		<table border="0" cellspacing="2" cellpadding="2" width="90%">
		<tr>
		<td align="center"><b>Forum</b></td>
		<td align="center"><b>User</b></td>
		<td align="center"><b>Unsubscribe?</b></td>
		<td align="center"><b>Ban?</b></td>
		</tr>
		
		<?php
		foreach ( $subs as $subkey => $subval )
		{
			if ( $subkey == 0 )
			{
				continue;
			}
			
			?>
			<tr>
			<td align="center">
			<a href="viewforum.php?fid=<?php print $subval["fid"]; ?>"><?php print $subval["fname"]; ?></a>
			</td>
			<td align="center">
			<a href="viewprofile.php?userid=<?php print $subval["userid"]; ?>"><?php print $subval["fullname"] . " (" . $subval["email"] . ")"; ?></a>
			</td>
			<td align="center">
			<input type="checkbox" name="uns<?php print $subval["fid"] . "-" . $subval["userid"]; ?>" id="uns<?php print $subval["fid"] . "-" . $subval["userid"]; ?>" value="1" />
			</td>
			<td align="center">
			<input type="checkbox" name="ban<?php print $subval["fid"] . "-" . $subval["userid"]; ?>" id="ban<?php print $subval["fid"] . "-" . $subval["userid"]; ?>" value="1" />
			</td>
			</tr>
			
			<?php
		}
		
		?>
		</table>
		
		<br />
		
		<input type="submit" name="submitform" value="Save Changes" />
		
		</form>
		
		<?php
	}
	
	if ( $isadmin == TRUE )
	{
		?>
		<hr width="100%" />
		
		<h3 style="color: #005000" name="manage" id="manage">Manage Forums</h3>
		
		<?php
		
		$forumsdata = array();
		$forumsdata = LoadForums();
		
		if ( $forumsdata[0] == 0 )
		{
			print "There are no forums.  Perhaps you should create one?";
		}
		else if ( $isadmin == FALSE )
		{
			print "You must be an admin to manage forums.";
		}
		else
		{
			?>
			<form name="mform" id="mform" action="moderate.php" method="POST">
			
			<input type="hidden" name="formstage" value="3" />
			
			<table border="0" cellspacing="2" cellpadding="2" width="90%">
			<tr>
			<td align="center"><b>Forum Name</b></td>
			<td align="center"><b>Public?</b></td>
			<td align="center"><b>Closed?</b></td>
			<td align="center"><b>Visible?</b></td>
			<td align="center"><b>HourMax</b></td>
			<td align="center"><b>DayMax</b></td>
			<td align="center"><b>Advanced Edit</b></td>
			</tr>
			
			<?php
			foreach ( $forumsdata as $fkey => $fval )
			{
				if ( $fkey == 0 )
				{
					continue;
				}
				
				if ( $fval["isclosed"] == 1 )
				{
					$clochecked = " checked";
				}
				else
				{
					$clochecked = NULL;
				}
				
				if ( $fval["fvisible"] == 1 )
				{
					$vischecked = " checked";
				}
				else
				{
					$vischecked = NULL;
				}
				
				?>
				<tr>
				<td align="center">
				<a href="viewforum.php?fid=<?php print $fval["fid"]; ?>"><?php print $fval["fname"]; ?></a>
				</td>
				<td align="center">
				<select name="pub<?php print $fval["fid"]; ?>" id="pub<?php print $fval["fid"]; ?>">
				<option value="1">All</option>
				<option value="2">View</option>
				<option value="3">No</option>
				</select>
				</td>
				<td align="center">
				<select name="clo<?php print $fval["fid"]; ?>" id="clo<?php print $fval["fid"]; ?>">
				<option value="0">Open</option>
				<option value="1">CLOSED</option>
				<option value="2">No New Posts</option>
				<option value="3">Admin-Only</option>
				<option value="4">Admin-Only Posts</option>
				</select>
				</td>
				<td align="center">
				<input type="checkbox" name="vis<?php print $fval["fid"]; ?>" id="vis<?php print $fval["fid"]; ?>" value="1"<?php print $vischecked; ?> />
				</td>
				<td align="center">
				<input type="text" size="1" name="hrm<?php print $fval["fid"]; ?>" id="hrm<?php print $fval["fid"]; ?>" value="<?php print $fval["maxpostsperhour"]; ?>" />
				</td>
				<td align="center">
				<input type="text" size="1" name="dam<?php print $fval["fid"]; ?>" id="dam<?php print $fval["fid"]; ?>" value="<?php print $fval["maxpostsperday"]; ?>" />
				</td>
				<td align="center">
				<a href="advancededit.php?fid=<?php print $fval["fid"]; ?>">Manage</a>
				</td>
				</tr>
				
				<script language="JavaScript">
				document.mform.pub<?php print $fval["fid"]; ?>.value=<?php print $fval["ispublic"]; ?>;
				document.mform.clo<?php print $fval["fid"]; ?>.value=<?php print $fval["isclosed"]; ?>;
				</script>
				
				<?php
			}
			
			?>
			</table>
			
			<br />
			
			<input type="submit" name="submitform" value="Save Changes" />
			
			</form>
			
			<hr width="100%" />
			
			<?php
		}
		
		?>
		<h3 style="color: #005000" name="create" id="create">Create New Forum</h3>
		
		<?php
		
		if ( $isadmin == FALSE )
		{
			print "You must be an admin to create forums.";
		}
		else
		{
			?>
			<form name="cform" id="cform" action="moderate.php" method="POST">
			
			<input type="hidden" name="formstage" id="formstage" value="4" />
			
			<table border="0" cellspacing="2" cellpadding="2" width="90%">
			<tr>
			<td align="right">
			<b>Forum Name:</b> &nbsp;
			</td>
			<td>
			<input type="text" name="s_fname" id="s_fname" maxlength="22" size="30" />
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Brief Description:</b> &nbsp;
			</td>
			<td>
			<input type="text" name="s_fdescription" id="s_fdescription" maxlength="250" size="55" />
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Max Posts Per Hour:</b> &nbsp;
			</td>
			<td>
			<input type="text" name="s_maxpostsperhour" id="s_maxpostsperhour" maxlength="3" size="1" /> 
			<span style="font-size: 10pt; color: navy">0 = Unlimited</span>
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Max Posts Per Day:</b> &nbsp;
			</td>
			<td>
			<input type="text" name="s_maxpostsperday" id="s_maxpostsperday" maxlength="3" size="1" /> 
			<span style="font-size: 10pt; color: navy">0 = Unlimited</span>
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Public Forum?</b> &nbsp;
			</td>
			<td>
			<select name="s_ispublic" id="s_ispublic">
			<option value="1">All Users Can View/Post</option>
			<option value="2">Only Subscribed Users May Post, But Everyone Can View</option>
			<option value="3">Nobody Can View or Post Unless Subscribed</option>
			</select>
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Closed Forum?</b> &nbsp;
			</td>
			<td>
			<select name="s_isclosed" id="s_isclosed">
			<option value="0">Open</option>
			<option value="1">CLOSED</option>
			<option value="2">No New Posts</option>
			<option value="3">Closed, EXCEPT for Admins</option>
			<option value="4">No New Posts, EXCEPT for Admins</option>
			</select>
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Visible to Non-Subscribers?</b> &nbsp;
			</td>
			<td>
			<input type="radio" name="s_fvisible" id="s_fvisible" value="1" checked /> Yes &nbsp;
			<input type="radio" name="s_fvisible" id="s_fvisible" value="0" /> No
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>Subscription Policy:</b> &nbsp;
			</td>
			<td>
			<select name="s_subscriptionpolicy" id="s_subscriptionpolicy">
			<option value="0">CLOSED to New Subscriptions</option>
			<option value="1" selected>Allow & Approve New Subscriptions Automatically</option>
			<option value="2">New Subscription Requests Require Approval</option>
			<option value="3">New Subscriptions by Invitation Only</option>
			</select>
			</td>
			</tr>
			<tr>
			<td align="right">
			<b>"Recommended" Digest Setting:</b> &nbsp;
			</td>
			<td>
			<select name="s_fdigestdefault" id="s_fdigestdefault">
			<option value="0">No Digest Emails</option>
			<option value="1" selected>Receive All Digest Emails</option>
			<option value="2">Digest Email for Topic-Starter Only</option>
			<option value="3">Digest Email for Topic-Starter + 1 Reply Notification</option>
			</select>
			</td>
			</tr>
			<tr>
			<td align="right" valign="top">
			<b>Assign Moderators:</b> &nbsp;
			</td>
			<td>
			<?php
			
			$query = "select users.userid, profiles.fullname, users.email from users, profiles where users.userid=profiles.userid AND ( users.status='ACTIVE' OR users.status='ADMIN' ) ORDER BY profiles.fullname ASC";
			$resulttl11 = mysql_query( $query ) or die( "Query '$query' failed for resulttl11 in moderate.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resulttl11, MYSQL_ASSOC ) )
			{
				$sqloop = 0;
				$userid = NULL;
				$username = NULL;
				$email = NULL;
				foreach ( $line as $col_value )
				{
					$fieldname = mysql_field_name( $resulttl11, $sqloop );
					$$fieldname = $col_value;
					$sqloop++;
				}
				if ( trim( $userid ) == NULL || trim( $fullname ) == NULL 
					|| trim( $email ) == NULL || !is_numeric( $userid ) )
				{
					continue;
				}
				?>
				<input type="checkbox" name="s_mod<?php print $userid; ?>" id="s_mod<?php print $userid; ?>" /> 
				<a href="viewprofile.php?userid=<?php print $userid; ?>"><?php print $fullname . " (" . $email . ")"; ?></a>
				<br />
				<?php
			}
			
			?>
			</td>
			</tr>
			</table>
			
			<br />
			
			<input type="submit" name="submitform" value="Create Forum" />
			
			</form>
	
			<?php
		}
	}
}

?>
</td>

<td bgcolor="#90EE90" valign="TOP">

<img src="images/space1px.gif" height="13" width="13"></td>

<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" /></td>

</tr>
</table>

</td>
</tr>

<tr>
<td></td>
<td>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td width="8"><img src="images/botleftb.gif" width="8" height="8" alt="" /></td>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="1" height="8" alt="" /></td>

<td width="11"><img src="images/botrightb.gif" width="11" height="8" alt="" /></td>
</tr>
</table>

</td>
</tr>

</table>

<?php
GenerateBottom();
GenerateFooter();
